<?php defined('_JEXEC') or die('Restricted access'); ?>
<?php
$this->form_prefix = 'billing_input_';

$config = Tienda::getInstance();
$one_page = $config->get('one_page_checkout', 0);
$guest_enabled = $config->get('guest_checkout_enabled', 0);

switch($this->form_prefix)
{
    case 'shipping_input_':
        $address_type = '2';
        break;
    default:
    case 'billing_input_':
        $address_type = '1';
        break;
}
$elements  = TiendaHelperAddresses::getAddressElementsData( $address_type );
$js_strings = array( 'COM_TIENDA_UPDATING_SHIPPING_RATES', 'COM_TIENDA_UPDATING_CART', 'COM_TIENDA_UPDATING_ADDRESS',  'COM_TIENDA_UPDATING_PAYMENT_METHODS' );
TiendaHelperAddresses::addJsTranslationStrings( $js_strings );
$addressTable = $this->getModel('addresses')->getTable();
?>

<form id="opc-billing-form" name="opc-billing-form" action="" method="post">

    <?php if (!empty($this->user->id) && !empty($this->addresses)) { ?>
    <fieldset id="existing-billing-addresses">
        <select id="existing-billing-address" name="billing_address_id">
            <?php foreach ($this->addresses as $address) { ?>
                <option value="<?php echo $address->address_id; ?>"><?php echo is_a($address, 'TiendaTableAddresses') ? $address->getSummary() : $addressTable->getSummary( $address ); ?></option>
            <?php } ?>
            <option id="create-new-billing-address" value="0"><?php echo JText::_( "COM_TIENDA_NEW_ADDRESS" ); ?></option>
        </select>
    </fieldset>
    <?php } ?>
    
    <fieldset id="new-billing-address" class="<?php if (!empty($this->user->id) && !empty($this->addresses)) { echo "opc-hidden"; } ?>">
    	<?php
		if( $elements['address_name'][0] ) 
		{
			if( $this->guest && !$one_page )
			{
				echo '<input value="'.JText::_('COM_TIENDA_TEMPORARY').'" name="'.$this->form_prefix.'address_name" id="'.$this->form_prefix.'address_name" type="hidden" />';
			}
			else
			{
				?>
				<div class="control-group">
                    <label for="<?php echo $this->form_prefix; ?>address_name"><?php echo JText::_('COM_TIENDA_ADDRESS_TITLE'); ?>
                    	<?php echo JText::_('COM_TIENDA_ADDRESS_TITLE_FOR_YOUR_REFERENCE'); ?>
                    </label>
                    <input name="<?php echo $this->form_prefix; ?>address_name" id="<?php echo $this->form_prefix; ?>address_name" class="<?php if( $elements['address_name'][1] ) { echo "required"; } ?>" type="text" maxlength="250" data-required="<?php echo $elements['address_name'][1] ? 'true' : false; ?>" />
                </div>
				<?php
			}
		}
		?>

    	<?php if( $elements['title'][0] ) :?>
		<div class="control-group">
			<label for="<?php echo $this->form_prefix; ?>title">
				<?php echo JText::_('COM_TIENDA_TITLE'); ?>
			</label>
			<input name="<?php echo $this->form_prefix; ?>title" id="<?php echo $this->form_prefix; ?>title" class="<?php if( $elements['title'][1] ) { echo "required"; } ?>" type="text" maxlength="250" data-required="<?php echo $elements['title'][1] ? 'true' : false; ?>" />
		</div>
		<?php endif; ?>
    
    	<?php if( $elements['name'][0] ) :?>
		<div class="control-group">
			<label for="<?php echo $this->form_prefix; ?>first_name">
				<?php echo JText::_('COM_TIENDA_FIRST_NAME'); ?>
			</label>
			<input name="<?php echo $this->form_prefix; ?>first_name"	id="<?php echo $this->form_prefix; ?>first_name" class="<?php if( $elements['name'][1] ) { echo "required"; } ?>" type="text" maxlength="250" data-required="<?php echo $elements['name'][1] ? 'true' : false; ?>" />
		</div>
		<?php endif; ?>
    
		<?php if( $elements['middle'][0] ) :?>
		<div class="control-group">
			<label for="<?php echo $this->form_prefix; ?>middle_name">
				<?php echo JText::_('COM_TIENDA_MIDDLE_NAME'); ?> 
			</label>
			<input type="text" name="<?php echo $this->form_prefix; ?>middle_name" id="<?php echo $this->form_prefix; ?>middle_name" class="<?php if( $elements['middle'][1] ) { echo "required"; } ?>" maxlength="250" data-required="<?php echo $elements['middle'][1] ? 'true' : false; ?>" />
		</div>
		<?php endif; ?>
    
        <?php if( $elements['last'][0] ) :?>
        <div class="control-group">
        	<label for="<?php echo $this->form_prefix; ?>last_name">
        		<?php echo JText::_('COM_TIENDA_LAST_NAME'); ?>
        	</label>
        	<input type="text" name="<?php echo $this->form_prefix; ?>last_name" id="<?php echo $this->form_prefix; ?>last_name" class="<?php if( $elements['last'][1] ) { echo "required"; } ?>" size="45" maxlength="250" data-required="<?php echo $elements['last'][1] ? 'true' : false; ?>" />
        </div>
        <?php endif; ?>

    	<?php if( $elements['company'][0] ) :?>
		<div class="control-group">
			<label for="<?php echo $this->form_prefix; ?>company">
				<?php echo JText::_('COM_TIENDA_COMPANY'); ?>
			</label>
			<input type="text" name="<?php echo $this->form_prefix; ?>company" id="<?php echo $this->form_prefix; ?>company" class="<?php if( $elements['company'][1] ) { echo "required"; } ?>" size="48" maxlength="250" data-required="<?php echo $elements['company'][1] ? 'true' : false; ?>" />
		</div>
		<?php endif; ?>
    		
		<?php if( $elements['tax_number'][0] ) :?>
		<div class="control-group">
			<label for="<?php echo $this->form_prefix; ?>tax_number">
				<?php echo JText::_('COM_TIENDA_CO_TAX_NUMBER'); ?>
			</label>
			<input type="text" name="<?php echo $this->form_prefix; ?>tax_number" id="<?php echo $this->form_prefix; ?>tax_number" class="<?php if( $elements['tax_number'][1] ) { echo "required"; } ?>" size="48" maxlength="250" data-required="<?php echo $elements['tax_number'][1] ? 'true' : false; ?>" />
		</div>
		<?php endif; ?>

    
    	<?php if( $elements['address1'][0] ) :?>
    	<div class="control-group">
    		<label for="<?php echo $this->form_prefix; ?>address_1">
    			<?php echo JText::_('COM_TIENDA_ADDRESS_LINE_1'); ?>
    		</label>
    		<input type="text"	name="<?php echo $this->form_prefix; ?>address_1" id="<?php echo $this->form_prefix; ?>address_1" class="<?php if( $elements['address1'][1] ) { echo "required"; } ?>" size="48" maxlength="250" data-required="<?php echo $elements['address1'][1] ? 'true' : false; ?>" />
    	</div>
    	<?php endif; ?>
    	
    	<?php if( $elements['address2'][0] ) :?>
    	<div class="control-group">
    		<label for="<?php echo $this->form_prefix; ?>address_2">
    			<?php echo JText::_('COM_TIENDA_ADDRESS_LINE_2'); ?>
    		</label>
    		<input type="text" name="<?php echo $this->form_prefix; ?>address_2" id="<?php echo $this->form_prefix; ?>address_2" class="<?php if( $elements['address2'][1] ) { echo "required"; } ?>" size="48" maxlength="250" data-required="<?php echo $elements['address2'][1] ? 'true' : false; ?>" />
    	</div>
    	<?php endif; ?>
    
    	<?php if( $elements['country'][0] ) :?>
    	<div class="control-group">
    		<label class="key">
    			<?php echo JText::_('COM_TIENDA_COUNTRY'); ?>
    		</label>
    		<?php
    		$url = "index.php?option=com_tienda&format=raw&controller=checkout&task=getzones&prefix={$this->form_prefix}&country_id=";
    
    		$onchange = 'tiendaDoTask( \''.$url.'\'+document.getElementById(\''.$this->form_prefix.'country_id\').value, \''.$this->form_prefix.'zones_wrapper\', \'\', \'\', false );';
    
    		$attribs = array('class' => 'required','size' => '1','onchange' => $onchange );
    		echo TiendaSelect::country( $this->default_country_id, $this->form_prefix.'country_id', $attribs, $this->form_prefix.'country_id', false, true );
    		?>
    	</div>
    	<?php endif; ?>
    
    	<?php if( $elements['city'][0] ) :?>
    	<div class="control-group">
    		<label for="<?php echo $this->form_prefix; ?>city">
    			<?php echo JText::_('COM_TIENDA_CITY'); ?>
    		</label>
    		<input type="text" name="<?php echo $this->form_prefix; ?>city" id="<?php echo $this->form_prefix; ?>city" class="<?php if( $elements['city'][1] ) { echo "required"; } ?>" size="48" maxlength="250" />
    	</div>
    	<?php endif; ?>
    
		<?php if( $elements['zone'][0] ) :?>
		<div class="control-group">
			<label class="key">
				<?php echo JText::_('COM_TIENDA_STATE_PROVINCE'); ?>
			</label>
			<div id="<?php echo $this->form_prefix; ?>zones_wrapper">
				<?php
			    $attribs = array('class' => 'required','size' => '1' );
				echo TiendaSelect::zone( '', $this->form_prefix.'zone_id', $this->default_country_id , $attribs, $this->form_prefix.'zone_id' );
				?>
			</div>
		</div>
		<?php endif; ?>
    
    	<?php if( $elements['zip'][0] ) :?>
		<div class="control-group">
			<label for="<?php echo $this->form_prefix; ?>postal_code">
				<?php echo JText::_('COM_TIENDA_POSTAL_CODE'); ?>
			</label>
			
			<?php $onchange = ''; ?>
			<input type="text" name="<?php echo $this->form_prefix; ?>postal_code" id="<?php echo $this->form_prefix; ?>postal_code" class="<?php if( $elements['zip'][1] ) { echo "required"; } ?>" size="25" maxlength="250" <?php if ( !empty( $onchange ) ) { ?> onchange="<?php echo $onchange; ?>" <?php } ?> />
		</div>
		<?php endif; ?>
    
    	<?php if( $elements['phone'][0] ) :?>
    	<div class="control-group">
    		<label name="<?php echo $this->form_prefix; ?>phone_1">
    			<?php echo JText::_('COM_TIENDA_PHONE'); ?>
    		</label>
    		<input name="<?php echo $this->form_prefix; ?>phone_1" id="<?php echo $this->form_prefix; ?>phone_1" class="<?php if( $elements['phone'][1] ) { echo "required"; } ?>" type="text" size="25" maxlength="250" data-required="<?php echo $elements['phone'][1] ? 'true' : false; ?>" />
    	</div>
    	<?php endif; ?>
    
    	<?php
    	$data = new JObject();
    	$dispatcher = JDispatcher::getInstance();
    	$dispatcher->trigger('onAfterDisplayAddressDetails', array($data, $this->form_prefix) );
    	?>
    	
    	<?php if (!empty($this->showShipping)) { ?>
        <ul class="unstyled control-group">
            <li class="control">            
                <label for="<?php echo $this->form_prefix; ?>use_for_shipping_yes" class="radio">
                    <input type="radio" value="1" id="<?php echo $this->form_prefix; ?>use_for_shipping_yes" name="<?php echo $this->form_prefix; ?>use_for_shipping" class="required">
                    <?php echo JText::_('COM_TIENDA_SHIP_TO_THIS_ADDRESS'); ?>
                </label>
            </li>
    
            <li class="control">
                <label for="<?php echo $this->form_prefix; ?>use_for_shipping_no" class="radio">
                    <input type="radio" value="0" id="<?php echo $this->form_prefix; ?>use_for_shipping_no" name="<?php echo $this->form_prefix; ?>use_for_shipping" class="required">
                    <?php echo JText::_( "COM_TIENDA_SHIP_TO_DIFFERENT_ADDRESS" ); ?>
                </label>
            </li>    
        </ul>
    	<?php } ?>
    </fieldset>
    
    <a id="opc-billing-button" class="btn btn-primary"><?php echo JText::_('COM_TIENDA_CONTINUE') ?></a>
  	
</form>